////////////////////////////////////////////////////////////////////////////////
// FileEntry.h : Declaration of the FileEntry
//
// Updated: 15th March 2005

#ifndef __FILEENTRY_H_
#define __FILEENTRY_H_

#include "resource.h"       // main symbols

////////////////////////////////////////////////////////////////////////////////
// FileEntry

class ATL_NO_VTABLE FileEntry
	: public CComObjectRootEx<CComMultiThreadModelNoCS>
	, public CComCoClass<FileEntry, &CLSID_FileEntry>
	, public IDispatchImpl<IFileEntry2, &IID_IFileEntry2, &LIBID_RECLS_COMLib>
	, public atlstl::SupportErrorInfoImpl2<&IID_IFileEntry, &IID_IFileEntry2>
{
public:
	FileEntry()
		: m_entry(NULL)
	{}
	~FileEntry()
	{
		if(NULL != m_entry)
		{
			Recls_CloseDetails(m_entry);
		}
	}

	void SetVoid(void const *pv)
	{
		m_entry = (info_t)pv;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_FILEENTRY)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(FileEntry)
	COM_INTERFACE_ENTRY(IFileEntry)
	COM_INTERFACE_ENTRY(IFileEntry2)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// IFileEntry
public:
	STDMETHOD(get_Path)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_Drive)(/*[out, retval]*/ OLECHAR *pVal);
	STDMETHOD(get_Directory)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_DirectoryPath)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_DirectoryParts)(/*[out, retval]*/ LPUNKNOWN *pVal);
	STDMETHOD(get_File)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_ShortFile)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_FileName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_FileExt)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_CreationTime)(/*[out, retval]*/ DATE *pVal);
	STDMETHOD(get_ModificationTime)(/*[out, retval]*/ DATE *pVal);
	STDMETHOD(get_LastAccessTime)(/*[out, retval]*/ DATE *pVal);
	STDMETHOD(get_LastStatusChangeTime)(/*[out, retval]*/ DATE *pVal);
	STDMETHOD(get_Size)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_IsReadOnly)(/*[out, retval]*/ BOOL *pVal);
	STDMETHOD(get_IsDirectory)(/*[out, retval]*/ BOOL *pVal);

// IFileEntry2
public:
	STDMETHOD(get_UNCDrive)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_IsLink)(/*[out, retval]*/ BOOL *pVal);
	STDMETHOD(get_IsUNC)(/*[out, retval]*/ BOOL *pVal);

// Implementation
private:
	HRESULT GetStringProperty_(size_t (RECLS_CALLCONV_DEFAULT *)(info_t, recls_char_t *, size_t), BSTR *pVal);
	HRESULT GetTimeProperty_(recls_time_t recls_fileinfo_t::*pm, DATE *pVal);

// Members
private:
	info_t	m_entry;
};

////////////////////////////////////////////////////////////////////////////////

#endif //__FILEENTRY_H_

////////////////////////////////////////////////////////////////////////////////
