/* /////////////////////////////////////////////////////////////////////////////
 * File:        recls_atomic.h
 *
 * Purpose:     Implementation header.
 *
 * Created:     11th March 2005
 * Updated:     6th May 2005
 *
 * Home:        http://recls.org/
 *
 * Copyright 2005, Matthew Wilson and Synesis Software
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted in accordance with the license and warranty
 * information described in recls.h (included in this distribution, or available
 * from http://recls.org/)
 *
 * ////////////////////////////////////////////////////////////////////////// */


#ifndef RECLS_INCL_H_RECLS_ATOMIC
#define RECLS_INCL_H_RECLS_ATOMIC

/* File version */
#ifndef RECLS_DOCUMENTATION_SKIP_SECTION
# define RECLS_VER_H_RECLS_ATOMIC_MAJOR     1
# define RECLS_VER_H_RECLS_ATOMIC_MINOR     0
# define RECLS_VER_H_RECLS_ATOMIC_REVISION  3
# define RECLS_VER_H_RECLS_ATOMIC_EDIT      4
#endif /* !RECLS_DOCUMENTATION_SKIP_SECTION */

/** \file recls_atomic.h Implementation header
 */

/* /////////////////////////////////////////////////////////////////////////////
 * Includes
 */

/* recls Header Files */
#include <recls.h>
#include "recls_impl.h"

/* /////////////////////////////////////////////////////////////////////////////
 * Namespace
 */

#if !defined(RECLS_NO_NAMESPACE)
namespace recls
{
#endif /* !RECLS_NO_NAMESPACE */

/* /////////////////////////////////////////////////////////////////////////////
 * Typedefs
 */

#if defined(RECLS_PLATFORM_IS_UNIX) && \
    defined(_RECLS_MT) && \
    defined(RECLS_UNIX_USE_ATOMIC_OPERATIONS)
typedef atomic_t                rc_atomic_t;
# define rc_atomic_init(x)      ATOMIC_INIT(x)
#else /* ? _RECLS_MT && RECLS_UNIX_USE_ATOMIC_OPERATIONS */
typedef recls_sint32_t          rc_atomic_t;
# define rc_atomic_init(x)      x
#endif /* _RECLS_MT && RECLS_UNIX_USE_ATOMIC_OPERATIONS */

/* /////////////////////////////////////////////////////////////////////////////
 * Functions
 */

RECLS_FNDECL(void)          RC_Increment(rc_atomic_t volatile *p);
RECLS_FNDECL(rc_atomic_t)   RC_PreDecrement(rc_atomic_t volatile *p);
RECLS_FNDECL(rc_atomic_t)   RC_ReadValue(rc_atomic_t volatile *p);

/* /////////////////////////////////////////////////////////////////////////////
 * Namespace
 */

#if !defined(RECLS_NO_NAMESPACE)
} /* namespace recls */
#endif /* !RECLS_NO_NAMESPACE */

/* ////////////////////////////////////////////////////////////////////////// */

#endif /* !RECLS_INCL_H_RECLS_ATOMIC */

/* ////////////////////////////////////////////////////////////////////////// */
