/* /////////////////////////////////////////////////////////////////////////////
 * File:        recls_util.h
 *
 * Purpose:     Implementation header.
 *
 * Created:     17th August 2003
 * Updated:     6th May 2005
 *
 * Home:        http://recls.org/
 *
 * Copyright 2003-2005, Matthew Wilson and Synesis Software
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted in accordance with the license and warranty
 * information described in recls.h (included in this distribution, or available
 * from http://recls.org/)
 *
 * ////////////////////////////////////////////////////////////////////////// */


#ifndef RECLS_INCL_H_RECLS_UTIL
#define RECLS_INCL_H_RECLS_UTIL

/* File version */
#ifndef RECLS_DOCUMENTATION_SKIP_SECTION
# define RECLS_VER_H_RECLS_UTIL_MAJOR       2
# define RECLS_VER_H_RECLS_UTIL_MINOR       4
# define RECLS_VER_H_RECLS_UTIL_REVISION    3
# define RECLS_VER_H_RECLS_UTIL_EDIT        23
#endif /* !RECLS_DOCUMENTATION_SKIP_SECTION */

/** \file recls_util.h Implementation header
 */

/* /////////////////////////////////////////////////////////////////////////////
 * Includes
 */

#include <recls.h>

/* /////////////////////////////////////////////////////////////////////////////
 * Namespace
 */

#if !defined(RECLS_NO_NAMESPACE)
namespace recls
{
#endif /* !RECLS_NO_NAMESPACE */

/* /////////////////////////////////////////////////////////////////////////////
 * Functions
 */

RECLS_LINKAGE_C recls_bool_t        is_dots(recls_char_t const *f);

RECLS_LINKAGE_C size_t              align_up_size(size_t i);

RECLS_LINKAGE_C size_t              count_char_instances(recls_char_t const *begin, recls_char_t const *end, recls_char_t const ch);

RECLS_LINKAGE_C size_t              recls_strncpy(recls_char_t *dest, size_t cchDest, recls_char_t const *src, size_t cchSrc);
RECLS_LINKAGE_C size_t              recls_strlen(recls_char_t const *dest);

RECLS_LINKAGE_C recls_char_t const  *find_directory_0(recls_char_t const *path);

RECLS_FNDECL(size_t)                Recls_GetStringProperty_(   struct recls_strptrs_t const    *ptrs
                                                            ,   recls_char_t                    *buffer
                                                            ,   size_t                          cchBuffer);

RECLS_FNDECL(recls_rc_t)            IsValidPattern(recls_char_t const *pattern, recls_uint32_t flags);

/* /////////////////////////////////////////////////////////////////////////////
 * Namespace
 */

#if !defined(RECLS_NO_NAMESPACE)
} /* namespace recls */
#endif /* !RECLS_NO_NAMESPACE */

/* ////////////////////////////////////////////////////////////////////////// */

#endif /* !RECLS_INCL_H_RECLS_UTIL */

/* ////////////////////////////////////////////////////////////////////////// */
