// This is the main project file for VC++ application project 
// generated using an Application Wizard.

#include "stdafx.h"

// Range enumerator

    /*__gc*/ class enumerator_range
    {
    public:
        enumerator_range(System::Collections::IEnumerator *en)
            : m_en(en)
        {
            operator ++(); // .NET enumerators require an initial MoveNext()
        }

/*
		template <typename T>
        enumerator_range(T *t)
            : m_en(t->GetEnumerator())
        {
            operator ++(); // .NET enumerators require an initial MoveNext()
        }
*/

        Object *operator *() const
        {
            message_assert("Attempting to use exhausted range!", !m_bExhausted);

            return m_en->get_Current();
        }

        enumerator_range &operator ++()
        {
            assert(NULL != m_en);
            message_assert("Attempting increment of exhausted range!", !m_bExhausted);

            m_bExhausted = !m_en->MoveNext();

            return *this;
        }

        // This would use the "proper" operator bool template from 
        // STLSoft
        operator bool () const
        {
            return !m_bExhausted;
        }

    private:
        System::Collections::IEnumerator    *m_en;
        bool                                m_bExhausted;
    };



// This is the entry point for this application
int _tmain(int argc, char **argv)
{
    // TODO: Please replace the sample code below with your own.
    Console::WriteLine(S"Managed C++ command-line test of recls");

#if 0
    recls::FileSearch                   *fs =   new recls::FileSearch(NULL, NULL, recls::RECLS_FLAG::RECLS_F_FILES);
    System::Collections::IEnumerator    *en =   fs->GetEnumerator();

    while(en->MoveNext())
    {
        recls::FileEntry    *entry  =   static_cast<recls::FileEntry*>(en->get_Current());
        String              *path   =   entry->get_Path();

        Console::WriteLine(S"Entry: {0}", path);
    }
#else /* ? 0 */
#if 1
    recls::FileSearch   *fs =   new recls::FileSearch(NULL, NULL, recls::RECLS_FLAG::RECLS_F_FILES);

    for(enumerator_range r(fs); r; ++r)
    {
        recls::FileEntry    *entry  =   static_cast<recls::FileEntry*>(*r);
        String              *path   =   entry->get_Path();

        Console::WriteLine(S"Entry: {0}", path);
    }
#else /* ? 0 */
    recls::FileSearch   *fs =   new recls::FileSearch(NULL, NULL, recls::RECLS_FLAG::RECLS_F_FILES);

    for(enumerator_range<FileEntry> r(fs); r; ++r)
    {
        Console::WriteLine(S"Entry: {0}", (*r)->get_Path());
    }
#endif /* 0 */
#endif /* 0 */

    return 0;
}
